<?php
/**
 * Этот скрипт предназначен для сжатия и архивации JS файлов.
 *
 * @author Стаценко Владимир <vova_33@gala.net>
 * @link http://www.simplecoding.org
 * @version 1.0
 */

//подключаем библиотеки
require_once 'libs/jsmin-1.1.1.php';

/**
 * Путь к папке со скриптами (отностильно этого скрипта)
 */
define('JS_DIR', "test_site/js/");

/**
 * Имя упакованного файла (будет размещен в папке со скриптами)
 */
define('JS_OUTPUT_FILE', 'global.js');

//определяем папку в которой находится скрипт
$scriptDir = substr($_SERVER['SCRIPT_FILENAME'], 0, strrpos($_SERVER['SCRIPT_FILENAME'], '/') + 1);

$resStr = "";

//открываем папку и получаем список файлов с расширением "js"
if ($dh = opendir($scriptDir.JS_DIR)) {
    while (false !== ($file = readdir($dh))) { 
        if ((substr($file, strrpos($file, '.') + 1) == "js") &&
        		($file != JS_OUTPUT_FILE)) {
        	$resStr .= "/*---------".$file."---------*/\n";
        	//сжимаем текущий файл
        	$resStr .= JSMin::minify(file_get_contents($scriptDir.JS_DIR.$file))."\n\n";
       	}
    }
    closedir($dh);
    //сохраняем сжатые данные в файл
    if ($fh = fopen($scriptDir.JS_DIR.JS_OUTPUT_FILE, 'w')) {
    	fwrite($fh, $resStr);
    	fclose($fh);
    }
    else {
    	echo "Ошибка: не могу открыть файл для записи: ".$scriptDir.JS_DIR.JS_OUTPUT_FILE;
    }
    
    echo "Скрипты упакованы файл: ".JS_DIR.JS_OUTPUT_FILE."<br />";

    //архивируем данные (используем самую высокую степень сжатия)
    $gzData = gzencode($resStr, 9);
    //создаем архив
    if ($fzip = fopen($scriptDir.JS_DIR.JS_OUTPUT_FILE.".gz", 'wb')) {
    	fwrite($fzip, $gzData);
    	fclose($fzip);
    }
    else {
    	echo "Ошибка: не могу открыть файл для записи: ".$scriptDir.JS_DIR.JS_OUTPUT_FILE.".gz";
    }
    
    echo "Создан архив: ".JS_DIR.JS_OUTPUT_FILE.".gz";
}
else {
	echo "Ошибка: не могу открыть папку со скриптами";
}
?>